
set echo on
set serveroutput on

DECLARE

   nt_passed_in ntt;
   nt_to_return ntt;

   FUNCTION pretend_parameter RETURN ntt IS
      nt ntt;
   BEGIN
      SELECT ot(NULL, 'X', SYSDATE) BULK COLLECT INTO nt
      FROM   dual
      CONNECT BY ROWNUM <= 5;
      RETURN nt;
   END pretend_parameter;

BEGIN

   nt_passed_in := pretend_parameter();

   FORALL i IN 1 .. nt_passed_in.COUNT
      INSERT INTO t (x, y, z)
      VALUES
      ( s.NEXTVAL
      , TREAT(nt_passed_in(i) AS ot).y
      , TREAT(nt_passed_in(i) AS ot).z
      )
      RETURNING ot(x, y, z)
      BULK COLLECT INTO nt_to_return;

   FOR i IN 1 .. nt_to_return.COUNT LOOP
      DBMS_OUTPUT.PUT_LINE(
         'Sequence value = [' || TO_CHAR(nt_to_return(i).x) || ']'
         );
   END LOOP;

END;
/

