
set echo on
set serveroutput on

CREATE TABLE t
( x INT PRIMARY KEY
, y NUMBER(10,2)
, z VARCHAR2(80)
);

DECLARE
   v_aggregate NUMBER;
BEGIN

   /* Step 1: load the data... */
   INSERT INTO t (x, y, z)
   SELECT ROWNUM                 AS x
   ,      ROWNUM/100             AS y
   ,      RPAD('x', 80)          AS z
   FROM   dual
   CONNECT BY ROWNUM <= 500000;

   /* Step 2: query it back to get the reporting value... */
   SELECT SUM(y) INTO v_aggregate FROM t;

   DBMS_OUTPUT.PUT_LINE(
      'Sum of column Y loaded = ' || TO_CHAR(v_aggregate)
      );
END;
/

TRUNCATE TABLE t;

CREATE GLOBAL TEMPORARY TABLE gtt
( aggregate_value NUMBER );

DECLARE
   v_aggregate NUMBER;
BEGIN

   /* Step 1: load the data and the aggregate... */
   INSERT ALL
      --<>--
      WHEN 1=1 THEN
      INTO t (x, y, z)
      VALUES (x, y, z)
      --<>--
      WHEN rn=1 THEN
      INTO gtt (aggregate_value)
      VALUES (sum_of_y)
      --<>--
   SELECT ROWNUM                  AS rn
   ,      ROWNUM                  AS x
   ,      ROWNUM/100              AS y
   ,      RPAD('x', 80)           AS z
   ,      SUM(ROWNUM/100) OVER () AS sum_of_y
   FROM   dual
   CONNECT BY ROWNUM <= 500000;

   /* Step 2: query the pre-aggregated value back... */
   SELECT aggregate_value INTO v_aggregate FROM gtt;

   DBMS_OUTPUT.PUT_LINE(
      'Sum of column Y loaded = ' || TO_CHAR(v_aggregate)
      );
END;
/

